/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/
#include "config.h"
#include "Ai8051U.h"
#include "usb.h"
#include "util.h"
#include "string.h"
#include "stdio.h"
#include <stdarg.h>

char xdata interfaceBuffer[64];

void usb_SendBlock(int len){
    USB_SendData((BYTE*)interfaceBuffer,len);
}


static void SEG7_SetHeader()
{
    interfaceBuffer[0] = '7';
    interfaceBuffer[1] = 'S';
    interfaceBuffer[2] = 'E';
    interfaceBuffer[3] = 'G';
}

void SEG7_ShowLong(long n, char radix)
{
    SEG7_SetHeader();
    interfaceBuffer[4] = 'L';
    interfaceBuffer[5] = 0x01;
    interfaceBuffer[6] = radix;
    interfaceBuffer[7] = 0x00;
    
    #if defined(_USE_SDCC_COMPILER_) || defined(_USE_IAR_COMPILER_)
        *(long *)&interfaceBuffer[8] = reverse4(n);
    #else
        *(long *)&interfaceBuffer[8] = n;
    #endif
    usb_SendBlock(12);
}

void SEG7_ShowFloat(float f)
{
    SEG7_SetHeader();
    interfaceBuffer[4] = 'D';
    interfaceBuffer[5] = 0x01;
    interfaceBuffer[6] = 0x00;
    interfaceBuffer[7] = 0x00;
    #if defined(_USE_SDCC_COMPILER_) || defined(_USE_IAR_COMPILER_)
        *(float *)&interfaceBuffer[8] = reversef(f);
    #else
        *(float *)&interfaceBuffer[8] = f;
    #endif

    usb_SendBlock(12);
}

void SEG7_ShowCode(BYTE *cod)
{
    SEG7_SetHeader();
    interfaceBuffer[4] = 'C';
    interfaceBuffer[5] = 0x00;
    interfaceBuffer[6] = 0x00;
    interfaceBuffer[7] = 0x00;
    memcpy(&interfaceBuffer[8], cod, 8);

    usb_SendBlock(16);
}

int SEG7_ShowString (const char *fmt, ...)
{
    va_list va;
    int ret;

    SEG7_SetHeader();
    interfaceBuffer[4] = 'S';
    interfaceBuffer[5] = 0x00;
    interfaceBuffer[6] = 0x00;
    interfaceBuffer[7] = 0x00;

    va_start(va, fmt);
    ret = vsprintf(&interfaceBuffer[8], fmt, va) + 8;
    va_end(va);

    usb_SendBlock((BYTE)(ret+1));

    return ret;
}

void LED40_SendData(BYTE *dat, BYTE size)
{
    if (size > 59)
        size = 59;

    interfaceBuffer[0] = 'L';
    interfaceBuffer[1] = 'E';
    interfaceBuffer[2] = 'D';
    interfaceBuffer[3] = 40;
    interfaceBuffer[4] = size;
    memcpy(&interfaceBuffer[5], dat, size);

    usb_SendBlock((BYTE)(size+5));
}

void LED64_SendData(BYTE *dat, BYTE size)
{
    if (size > 59)
        size = 59;

    interfaceBuffer[0] = 'L';
    interfaceBuffer[1] = 'E';
    interfaceBuffer[2] = 'D';
    interfaceBuffer[3] = 64;
    interfaceBuffer[4] = size;
    memcpy(&interfaceBuffer[5], dat, size);

    usb_SendBlock((BYTE)(size+5));
}

static void LCD12864_SetHeader()
{
    interfaceBuffer[0] = 'L';
    interfaceBuffer[1] = 'C';
    interfaceBuffer[2] = 'D';
    interfaceBuffer[3] = 128;
}

void LCD12864_DisplayOff()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa0;
    interfaceBuffer[6] = 0x00;

    usb_SendBlock(7);
}

void LCD12864_DisplayOn()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa0;
    interfaceBuffer[6] = 0x01;

    usb_SendBlock(7);
}

void LCD12864_CursorOff()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa1;
    interfaceBuffer[6] = 0x00;

    usb_SendBlock(7);
}

void LCD12864_CursorOn()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa1;
    interfaceBuffer[6] = 0x01;

    usb_SendBlock(7);
}

void LCD12864_CursorMoveLeft()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa2;
    interfaceBuffer[6] = 0x00;

    usb_SendBlock(7);
}

void LCD12864_CursorMoveRight()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa2;
    interfaceBuffer[6] = 0x01;

    usb_SendBlock(7);
}

void LCD12864_CursorReturnHome()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa2;
    interfaceBuffer[6] = 0x02;

    usb_SendBlock(7);
}

void LCD12864_ScrollLeft()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa3;
    interfaceBuffer[6] = 0x00;

    usb_SendBlock(7);
}

void LCD12864_ScrollRight()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa3;
    interfaceBuffer[6] = 0x01;

    usb_SendBlock(7);
}

void LCD12864_ScrollUp(BYTE line)
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 3;
    interfaceBuffer[5] = 0xa3;
    interfaceBuffer[6] = 0x02;
    interfaceBuffer[7] = line;

    usb_SendBlock(8);
}

void LCD12864_AutoWrapOff()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa4;
    interfaceBuffer[6] = 0x00;

    usb_SendBlock(7);
}

void LCD12864_AutoWrapOn()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa4;
    interfaceBuffer[6] = 0x01;

    usb_SendBlock(7);
}

void LCD12864_ReverseLine(BYTE line)
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xa5;
    interfaceBuffer[6] = line;

    usb_SendBlock(7);
}

void LCD12864_DisplayClear()
{
    LCD12864_SetHeader();
    interfaceBuffer[4] = 1;
    interfaceBuffer[5] = 0xa6;

    usb_SendBlock(6);
}

static void LCD12864_SetBuffer(BYTE *dat, WORD size)
{
    BYTE cnt;
    WORD addr;

    addr = 0;
    while (size)
    {
        cnt = 56;
        if (size < 56)
            cnt = size;

        LCD12864_SetHeader();
        interfaceBuffer[4] = cnt + 3;
        interfaceBuffer[5] = 0xaf;
        #if defined(_USE_SDCC_COMPILER_) || defined(_USE_IAR_COMPILER_)
        *(WORD *)&interfaceBuffer[6] = reverse2(addr);
        #else
        *(WORD *)&interfaceBuffer[6] = addr;
        #endif
        
        memcpy(&interfaceBuffer[8], dat, cnt);

        usb_SendBlock((BYTE)(cnt+8));

        dat += cnt;
        addr += cnt;
        size -= cnt;
    }
}

void LCD12864_ShowString(BYTE x, BYTE y, char *str)
{
    LCD12864_SetBuffer((BYTE*)str, strlen(str) + 1);

    LCD12864_SetHeader();
    interfaceBuffer[4] = 3;
    interfaceBuffer[5] = 0xa7;
    interfaceBuffer[6] = x;
    interfaceBuffer[7] = y;

    usb_SendBlock(8);
}

void LCD12864_ShowPicture(BYTE x, BYTE y, BYTE cx, BYTE cy, BYTE *dat)
{
    LCD12864_SetBuffer(dat, (WORD)(2UL*cx*cy));

    LCD12864_SetHeader();
    interfaceBuffer[4] = 5;
    interfaceBuffer[5] = 0xa8;
    interfaceBuffer[6] = x;
    interfaceBuffer[7] = y;
    interfaceBuffer[8] = cx;
    interfaceBuffer[9] = cy;

    usb_SendBlock(10);
}

static void OLED12864_SetHeader()
{
    interfaceBuffer[0] = 'O';
    interfaceBuffer[1] = 'L';
    interfaceBuffer[2] = 'E';
    interfaceBuffer[3] = 128;
}

void OLED12864_DisplayOff()
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc0;
    interfaceBuffer[6] = 0x00;

    usb_SendBlock(7);
}

void OLED12864_DisplayOn()
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc0;
    interfaceBuffer[6] = 0x01;

    usb_SendBlock(7);
}

void OLED12864_DisplayContent()
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc1;
    interfaceBuffer[6] = 0x00;

    usb_SendBlock(7);
}

void OLED12864_DisplayEntire()
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc1;
    interfaceBuffer[6] = 0x01;

    usb_SendBlock(7);
}

void OLED12864_HorizontalMirror()
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc2;
    interfaceBuffer[6] = 0x00;

    usb_SendBlock(7);
}

void OLED12864_VerticalMirror()
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc2;
    interfaceBuffer[6] = 0x01;

    usb_SendBlock(7);
}

void OLED12864_DisplayReverse()
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 1;
    interfaceBuffer[5] = 0xc3;

    usb_SendBlock(6);
}

void OLED12864_SetContrast(BYTE bContrast)
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc4;
    interfaceBuffer[6] = bContrast;

    usb_SendBlock(7);
}

void OLED12864_SetAddressMode(BYTE bMode)
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc5;
    interfaceBuffer[6] = bMode;

    usb_SendBlock(7);
}

void OLED12864_ScrollLeft(BYTE bPageStart, BYTE bPageEnd, WORD nInterval)
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 6;
    interfaceBuffer[5] = 0xc6;
    interfaceBuffer[6] = 0x00;
    interfaceBuffer[7] = bPageStart;
    interfaceBuffer[8] = bPageEnd;
    #if defined(_USE_SDCC_COMPILER_) || defined(_USE_IAR_COMPILER_)
    *(WORD *)&interfaceBuffer[9] = reverse2(nInterval);
    #else
    *(WORD *)&interfaceBuffer[9] = nInterval;
    #endif
    

    usb_SendBlock(11);
}

void OLED12864_ScrollRight(BYTE bPageStart, BYTE bPageEnd, WORD nInterval)
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 6;
    interfaceBuffer[5] = 0xc6;
    interfaceBuffer[6] = 0x01;
    interfaceBuffer[7] = bPageStart;
    interfaceBuffer[8] = bPageEnd;
    #if defined(_USE_SDCC_COMPILER_) || defined(_USE_IAR_COMPILER_)
    *(WORD *)&interfaceBuffer[9] = reverse2(nInterval);
    #else
    *(WORD *)&interfaceBuffer[9] = nInterval;
    #endif

    usb_SendBlock(11);
}

void OLED12864_ScrollUp(BYTE bPageStart, BYTE bPageEnd, WORD nInterval)
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 6;
    interfaceBuffer[5] = 0xc6;
    interfaceBuffer[6] = 0x02;
    interfaceBuffer[7] = bPageStart;
    interfaceBuffer[8] = bPageEnd;
    #if defined(_USE_SDCC_COMPILER_) || defined(_USE_IAR_COMPILER_)
    *(WORD *)&interfaceBuffer[9] = reverse2(nInterval);
    #else
    *(WORD *)&interfaceBuffer[9] = nInterval;
    #endif

    usb_SendBlock(11);
}

void OLED12864_ScrollStart()
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc7;
    interfaceBuffer[6] = 0x01;

    usb_SendBlock(7);
}

void OLED12864_ScrollStop()
{
    OLED12864_SetHeader();
    interfaceBuffer[4] = 2;
    interfaceBuffer[5] = 0xc7;
    interfaceBuffer[6] = 0x00;

    usb_SendBlock(7);
}

static void OLED12864_SetBuffer(BYTE *dat, WORD size)
{
    BYTE cnt;
    WORD addr;

    addr = 0;
    while (size)
    {
        cnt = 56;
        if (size < 56)
            cnt = size;

        OLED12864_SetHeader();
        interfaceBuffer[4] = cnt + 3;
        interfaceBuffer[5] = 0xcf;
        #if defined(_USE_SDCC_COMPILER_) || defined(_USE_IAR_COMPILER_)
        *(WORD *)&interfaceBuffer[6] = reverse2(addr);
        #else
        *(WORD *)&interfaceBuffer[6] = addr;
        #endif
        memcpy(&interfaceBuffer[8], dat, cnt);

        usb_SendBlock((BYTE)(cnt+8));

        dat += cnt;
        addr += cnt;
        size -= cnt;
    }
}

void OLED12864_ShowPicture(BYTE x, BYTE y, BYTE cx, BYTE cy, BYTE *dat)
{
    OLED12864_SetBuffer(dat, (WORD)cx*cy);

    OLED12864_SetHeader();
    interfaceBuffer[4] = 5;
    interfaceBuffer[5] = 0xc8;
    interfaceBuffer[6] = x;
    interfaceBuffer[7] = y;
    interfaceBuffer[8] = cx;
    interfaceBuffer[9] = cy;

    usb_SendBlock(10);
}

